unit library2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  op_class;

type
  TForm1 = class(TForm)
    QueryServer: TDLLServer;
    CanCloseTask: TTaskServer;
    TaskProp: TTaskServer;
    TaskServer1: TTaskServer;
    PropClient: TTaskClient;
    ColorDialog1: TColorDialog;
    procedure CanCloseTaskExecute(Sender: TObject;
      const Args: array of TVarRec; var Retval: Pointer);
    procedure CanCloseTaskCloseQuery(Sender: TObject;
      var CanClose: Boolean);
    procedure TaskPropRegistered(Sender: TObject);
    procedure TaskPropSetProperty(Sender: TObject; PropName: string;
      const Value: Variant);
    procedure TaskServer1Execute(Sender: TObject;
      const Args: array of TVarRec; var Retval: Pointer);
    procedure TaskPropExecute(Sender: TObject;
      const Args: array of TVarRec; var Retval: Pointer);
    procedure TaskPropGetProperty(Sender: TObject; PropName: string;
      var Value: Variant);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses propsmple;

{$R *.DFM}
procedure TForm1.CanCloseTaskExecute(Sender: TObject;
  const Args: array of TVarRec; var Retval: Pointer);
begin
 ShowMessage('Can close query sample executed');
 
end;

procedure TForm1.CanCloseTaskCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
 CanCLose := MessageDlg('Can close query asks for close. Yes, No?',
  mtConfirmation, [mbYes,mbNo],0) = mrYes;
end;

procedure TForm1.TaskPropRegistered(Sender: TObject);
begin
  Form2 := TForm2.Create(Application);
end;

procedure TForm1.TaskPropSetProperty(Sender: TObject; PropName: string;
  const Value: Variant);
begin
 if PropName = 'COLOR' Then Form2.Color := Value;
end;

procedure TForm1.TaskServer1Execute(Sender: TObject;
  const Args: array of TVarRec; var Retval: Pointer);
var
 I:Integer;
begin
 if ColorDialog1.Execute Then
  I := ColorDialog1.Color;
 OverPLAYApplication.GetTask('PROPSET').SetProperty('COLOR',I);
end;

procedure TForm1.TaskPropExecute(Sender: TObject;
  const Args: array of TVarRec; var Retval: Pointer);
begin
 ShowMessage('This task can not be executed');
end;

procedure TForm1.TaskPropGetProperty(Sender: TObject; PropName: string;
  var Value: Variant);
begin
 if PROPName = 'COLOR' Then
  Value := Form2.Color;
end;

initialization
 OverPLAYMainForm := TForm1;
end.
