unit modlibf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  op_class;

type
  TModLibForm = class(TForm)
    CalBrowse: TTaskServer;
    CalServer: TDLLServer;
    procedure CalBrowseExecute(Sender: TObject;
      const Args: array of TVarRec; var Retval: Pointer);
    procedure CalServerAfterRegister(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ModLibForm: TModLibForm;

implementation

uses CalBrows;

{$R *.DFM}
procedure TModLibForm.CalBrowseExecute(Sender: TObject;
  const Args: array of TVarRec; var Retval: Pointer);
var
 D:TDateTime;
begin
  CalendarBrowser := TCalendarBrowser.Create(Application);
  try
   if CalendarBrowser.ShowModal <> mrOK Then
     Retval := nil
     else
        With CalendarBrowser.Calendar1 do
         begin
          D := EncodeDate(Year,Month,Day);
          RetVal := @D;
         End;
   finally
    CalendarBrowser.Free;
   end;
end;

procedure TModLibForm.CalServerAfterRegister(Sender: TObject);
begin
  CalBrowse.NotifyAvailable(True);
end;

initialization
  OverPLAYMainForm := TModlibForm;

end.
